// Code generated by go-swagger; DO NOT EDIT.

package networks

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the generate command

import (
	"net/http"

	"github.com/go-openapi/runtime/middleware"
)

// VMNetworkGetHandlerFunc turns a function with the right signature into a vm network get handler
type VMNetworkGetHandlerFunc func(VMNetworkGetParams) middleware.Responder

// Handle executing the request and returning a response
func (fn VMNetworkGetHandlerFunc) Handle(params VMNetworkGetParams) middleware.Responder {
	return fn(params)
}

// VMNetworkGetHandler interface for that can handle valid vm network get params
type VMNetworkGetHandler interface {
	Handle(VMNetworkGetParams) middleware.Responder
}

// NewVMNetworkGet creates a new http.Handler for the vm network get operation
func NewVMNetworkGet(ctx *middleware.Context, handler VMNetworkGetHandler) *VMNetworkGet {
	return &VMNetworkGet{Context: ctx, Handler: handler}
}

/*VMNetworkGet swagger:route GET /api/networks/{id} Networks vmNetworkGet

Get network

*/
type VMNetworkGet struct {
	Context *middleware.Context
	Handler VMNetworkGetHandler
}

func (o *VMNetworkGet) ServeHTTP(rw http.ResponseWriter, r *http.Request) {
	route, rCtx, _ := o.Context.RouteInfo(r)
	if rCtx != nil {
		r = rCtx
	}
	var Params = NewVMNetworkGetParams()

	if err := o.Context.BindValidRequest(r, route, &Params); err != nil { // bind params
		o.Context.Respond(rw, r, route.Produces, route, err)
		return
	}

	res := o.Handler.Handle(Params) // actually handle the request

	o.Context.Respond(rw, r, route.Produces, route, res)

}
